
/***************************************************************************
 *
 *
 * MODULE:		KEYSYMDEF.H
 * DESCRIPTION:		Symbol values for key events
 * VERSION:		$Id: keysymdef.h,v 1.6 2000/04/20 15:45:33 n_hibma Exp $
 *
 * AUTHOR:		X Consortium
 * Created:		9 March 1999
 *
 *
 ***************************************************************************/

/* $TOG: keysymdef.h /main/25 1997/06/21 10:54:51 kaleb $ */

/***********************************************************
Copyright (c) 1987, 1994  X Consortium

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of the X Consortium shall
not be used in advertising or otherwise to promote the sale, use or
other dealings in this Software without prior written authorization
from the X Consortium.


Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of Digital not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

DEFKEY(VoidSymbol,		0xFFFFFF)	/* void symbol */

#ifdef KEY_MISCELLANY
/*
 * TTY Functions, cleverly chosen to map to ascii, for convenience of
 * programming, but could have been arbitrary (at the cost of lookup
 * tables in client code.
 */

DEFKEY(BackSpace,		0xFF08)	/* back space, back char */
DEFKEY(Tab,			0xFF09)
DEFKEY(Linefeed,		0xFF0A)	/* Linefeed, LF */
DEFKEY(Clear,		0xFF0B)
DEFKEY(Return,		0xFF0D)	/* Return, enter */
DEFKEY(Pause,		0xFF13)	/* Pause, hold */
DEFKEY(Scroll_Lock,		0xFF14)
DEFKEY(Sys_Req,		0xFF15)
DEFKEY(Escape,		0xFF1B)
DEFKEY(Delete,		0xFFFF)	/* Delete, rubout */



/* International & multi-key character composition */

DEFKEY(Multi_key,		0xFF20)  /* Multi-key character compose */
DEFKEY(SingleCandidate,	0xFF3C)
DEFKEY(MultipleCandidate,	0xFF3D)
DEFKEY(PreviousCandidate,	0xFF3E)

/* Japanese keyboard support */

DEFKEY(Kanji,		0xFF21)	/* Kanji, Kanji convert */
DEFKEY(Muhenkan,		0xFF22)  /* Cancel Conversion */
DEFKEY(Henkan_Mode,		0xFF23)  /* Start/Stop Conversion */
DEFKEY(Henkan,		0xFF23)  /* Alias for Henkan_Mode */
DEFKEY(Romaji,		0xFF24)  /* to Romaji */
DEFKEY(Hiragana,		0xFF25)  /* to Hiragana */
DEFKEY(Katakana,		0xFF26)  /* to Katakana */
DEFKEY(Hiragana_Katakana,	0xFF27)  /* Hiragana/Katakana toggle */
DEFKEY(Zenkaku,		0xFF28)  /* to Zenkaku */
DEFKEY(Hankaku,		0xFF29)  /* to Hankaku */
DEFKEY(Zenkaku_Hankaku,	0xFF2A)  /* Zenkaku/Hankaku toggle */
DEFKEY(Touroku,		0xFF2B)  /* Add to Dictionary */
DEFKEY(Massyo,		0xFF2C)  /* Delete from Dictionary */
DEFKEY(Kana_Lock,		0xFF2D)  /* Kana Lock */
DEFKEY(Kana_Shift,		0xFF2E)  /* Kana Shift */
DEFKEY(Eisu_Shift,		0xFF2F)  /* Alphanumeric Shift */
DEFKEY(Eisu_toggle,		0xFF30)  /* Alphanumeric toggle */
DEFKEY(Zen_Koho,		0xFF3D)	/* Multiple/All Candidate(s) */
DEFKEY(Mae_Koho,		0xFF3E)	/* Previous Candidate */

/* 0xFF31 thru 0xFF3F are under KEY_KOREAN */

/* Cursor control & motion */

DEFKEY(Home,			0xFF50)
DEFKEY(Left,			0xFF51)	/* Move left, left arrow */
DEFKEY(Up,			0xFF52)	/* Move up, up arrow */
DEFKEY(Right,		0xFF53)	/* Move right, right arrow */
DEFKEY(Down,			0xFF54)	/* Move down, down arrow */
DEFKEY(Prior,		0xFF55)	/* Prior, previous */
DEFKEY(Page_Up,		0xFF55)
DEFKEY(Next,			0xFF56)	/* Next */
DEFKEY(Page_Down,		0xFF56)
DEFKEY(End,			0xFF57)	/* EOL */
DEFKEY(Begin,		0xFF58)	/* BOL */


/* Misc Functions */

DEFKEY(Select,		0xFF60)	/* Select, mark */
DEFKEY(Print,		0xFF61)
DEFKEY(Execute,		0xFF62)	/* Execute, run, do */
DEFKEY(Insert,		0xFF63)	/* Insert, insert here */
DEFKEY(Undo,			0xFF65)	/* Undo, oops */
DEFKEY(Redo,			0xFF66)	/* redo, again */
DEFKEY(Menu,			0xFF67)
DEFKEY(Find,			0xFF68)	/* Find, search */
DEFKEY(Cancel,		0xFF69)	/* Cancel, stop, abort, exit */
DEFKEY(Help,			0xFF6A)	/* Help */
DEFKEY(Break,		0xFF6B)
DEFKEY(Mode_switch,		0xFF7E)	/* Character set switch */
DEFKEY(script_switch,        0xFF7E)  /* Alias for mode_switch */
DEFKEY(Num_Lock,		0xFF7F)

/* Keypad Functions, keypad numbers cleverly chosen to map to ascii */

DEFKEY(KP_Space,		0xFF80)	/* space */
DEFKEY(KP_Tab,		0xFF89)
DEFKEY(KP_Enter,		0xFF8D)	/* enter */
DEFKEY(KP_F1,		0xFF91)	/* PF1, KP_A, ... */
DEFKEY(KP_F2,		0xFF92)
DEFKEY(KP_F3,		0xFF93)
DEFKEY(KP_F4,		0xFF94)
DEFKEY(KP_Home,		0xFF95)
DEFKEY(KP_Left,		0xFF96)
DEFKEY(KP_Up,		0xFF97)
DEFKEY(KP_Right,		0xFF98)
DEFKEY(KP_Down,		0xFF99)
DEFKEY(KP_Prior,		0xFF9A)
DEFKEY(KP_Page_Up,		0xFF9A)
DEFKEY(KP_Next,		0xFF9B)
DEFKEY(KP_Page_Down,		0xFF9B)
DEFKEY(KP_End,		0xFF9C)
DEFKEY(KP_Begin,		0xFF9D)
DEFKEY(KP_Insert,		0xFF9E)
DEFKEY(KP_Delete,		0xFF9F)
DEFKEY(KP_Equal,		0xFFBD)	/* equals */
DEFKEY(KP_Multiply,		0xFFAA)
DEFKEY(KP_Add,		0xFFAB)
DEFKEY(KP_Separator,		0xFFAC)	/* separator, often comma */
DEFKEY(KP_Subtract,		0xFFAD)
DEFKEY(KP_Decimal,		0xFFAE)
DEFKEY(KP_Divide,		0xFFAF)

DEFKEY(KP_0,			0xFFB0)
DEFKEY(KP_1,			0xFFB1)
DEFKEY(KP_2,			0xFFB2)
DEFKEY(KP_3,			0xFFB3)
DEFKEY(KP_4,			0xFFB4)
DEFKEY(KP_5,			0xFFB5)
DEFKEY(KP_6,			0xFFB6)
DEFKEY(KP_7,			0xFFB7)
DEFKEY(KP_8,			0xFFB8)
DEFKEY(KP_9,			0xFFB9)



/*
 * Auxilliary Functions; note the duplicate definitions for left and right
 * function keys;  Sun keyboards and a few other manufactures have such
 * function key groups on the left and/or right sides of the keyboard.
 * We've not found a keyboard with more than 35 function keys total.
 */

DEFKEY(F1,			0xFFBE)
DEFKEY(F2,			0xFFBF)
DEFKEY(F3,			0xFFC0)
DEFKEY(F4,			0xFFC1)
DEFKEY(F5,			0xFFC2)
DEFKEY(F6,			0xFFC3)
DEFKEY(F7,			0xFFC4)
DEFKEY(F8,			0xFFC5)
DEFKEY(F9,			0xFFC6)
DEFKEY(F10,			0xFFC7)
DEFKEY(F11,			0xFFC8)
DEFKEY(L1,			0xFFC8)
DEFKEY(F12,			0xFFC9)
DEFKEY(L2,			0xFFC9)
DEFKEY(F13,			0xFFCA)
DEFKEY(L3,			0xFFCA)
DEFKEY(F14,			0xFFCB)
DEFKEY(L4,			0xFFCB)
DEFKEY(F15,			0xFFCC)
DEFKEY(L5,			0xFFCC)
DEFKEY(F16,			0xFFCD)
DEFKEY(L6,			0xFFCD)
DEFKEY(F17,			0xFFCE)
DEFKEY(L7,			0xFFCE)
DEFKEY(F18,			0xFFCF)
DEFKEY(L8,			0xFFCF)
DEFKEY(F19,			0xFFD0)
DEFKEY(L9,			0xFFD0)
DEFKEY(F20,			0xFFD1)
DEFKEY(L10,			0xFFD1)
DEFKEY(F21,			0xFFD2)
DEFKEY(R1,			0xFFD2)
DEFKEY(F22,			0xFFD3)
DEFKEY(R2,			0xFFD3)
DEFKEY(F23,			0xFFD4)
DEFKEY(R3,			0xFFD4)
DEFKEY(F24,			0xFFD5)
DEFKEY(R4,			0xFFD5)
DEFKEY(F25,			0xFFD6)
DEFKEY(R5,			0xFFD6)
DEFKEY(F26,			0xFFD7)
DEFKEY(R6,			0xFFD7)
DEFKEY(F27,			0xFFD8)
DEFKEY(R7,			0xFFD8)
DEFKEY(F28,			0xFFD9)
DEFKEY(R8,			0xFFD9)
DEFKEY(F29,			0xFFDA)
DEFKEY(R9,			0xFFDA)
DEFKEY(F30,			0xFFDB)
DEFKEY(R10,			0xFFDB)
DEFKEY(F31,			0xFFDC)
DEFKEY(R11,			0xFFDC)
DEFKEY(F32,			0xFFDD)
DEFKEY(R12,			0xFFDD)
DEFKEY(F33,			0xFFDE)
DEFKEY(R13,			0xFFDE)
DEFKEY(F34,			0xFFDF)
DEFKEY(R14,			0xFFDF)
DEFKEY(F35,			0xFFE0)
DEFKEY(R15,			0xFFE0)

/* Modifiers */

DEFKEY(Shift_L,		0xFFE1)	/* Left shift */
DEFKEY(Shift_R,		0xFFE2)	/* Right shift */
DEFKEY(Control_L,		0xFFE3)	/* Left control */
DEFKEY(Control_R,		0xFFE4)	/* Right control */
DEFKEY(Caps_Lock,		0xFFE5)	/* Caps lock */
DEFKEY(Shift_Lock,		0xFFE6)	/* Shift lock */

DEFKEY(Meta_L,		0xFFE7)	/* Left meta */
DEFKEY(Meta_R,		0xFFE8)	/* Right meta */
DEFKEY(Alt_L,		0xFFE9)	/* Left alt */
DEFKEY(Alt_R,		0xFFEA)	/* Right alt */
DEFKEY(Super_L,		0xFFEB)	/* Left super */
DEFKEY(Super_R,		0xFFEC)	/* Right super */
DEFKEY(Hyper_L,		0xFFED)	/* Left hyper */
DEFKEY(Hyper_R,		0xFFEE)	/* Right hyper */
#endif /* KEY_MISCELLANY */

/*
 * ISO 9995 Function and Modifier Keys
 * Byte 3 = 0xFE
 */

#ifdef KEY_XKB_KEYS
#define	KEY_ISO_Lock					0xFE01
#define	KEY_ISO_Level2_Latch				0xFE02
#define	KEY_ISO_Level3_Shift				0xFE03
#define	KEY_ISO_Level3_Latch				0xFE04
#define	KEY_ISO_Level3_Lock				0xFE05
#define	KEY_ISO_Group_Shift		0xFF7E	/* Alias for mode_switch */
#define	KEY_ISO_Group_Latch				0xFE06
#define	KEY_ISO_Group_Lock				0xFE07
#define	KEY_ISO_Next_Group				0xFE08
#define	KEY_ISO_Next_Group_Lock				0xFE09
#define	KEY_ISO_Prev_Group				0xFE0A
#define	KEY_ISO_Prev_Group_Lock				0xFE0B
#define	KEY_ISO_First_Group				0xFE0C
#define	KEY_ISO_First_Group_Lock				0xFE0D
#define	KEY_ISO_Last_Group				0xFE0E
#define	KEY_ISO_Last_Group_Lock				0xFE0F

#define	KEY_ISO_Left_Tab					0xFE20
#define	KEY_ISO_Move_Line_Up				0xFE21
#define	KEY_ISO_Move_Line_Down				0xFE22
#define	KEY_ISO_Partial_Line_Up				0xFE23
#define	KEY_ISO_Partial_Line_Down			0xFE24
#define	KEY_ISO_Partial_Space_Left			0xFE25
#define	KEY_ISO_Partial_Space_Right			0xFE26
#define	KEY_ISO_Set_Margin_Left				0xFE27
#define	KEY_ISO_Set_Margin_Right				0xFE28
#define	KEY_ISO_Release_Margin_Left			0xFE29
#define	KEY_ISO_Release_Margin_Right			0xFE2A
#define	KEY_ISO_Release_Both_Margins			0xFE2B
#define	KEY_ISO_Fast_Cursor_Left				0xFE2C
#define	KEY_ISO_Fast_Cursor_Right			0xFE2D
#define	KEY_ISO_Fast_Cursor_Up				0xFE2E
#define	KEY_ISO_Fast_Cursor_Down				0xFE2F
#define	KEY_ISO_Continuous_Underline			0xFE30
#define	KEY_ISO_Discontinuous_Underline			0xFE31
#define	KEY_ISO_Emphasize				0xFE32
#define	KEY_ISO_Center_Object				0xFE33
#define	KEY_ISO_Enter					0xFE34

#define	KEY_dead_grave					0xFE50
#define	KEY_dead_acute					0xFE51
#define	KEY_dead_circumflex				0xFE52
#define	KEY_dead_tilde					0xFE53
#define	KEY_dead_macron					0xFE54
#define	KEY_dead_breve					0xFE55
#define	KEY_dead_abovedot				0xFE56
#define	KEY_dead_diaeresis				0xFE57
#define	KEY_dead_abovering				0xFE58
#define	KEY_dead_doubleacute				0xFE59
#define	KEY_dead_caron					0xFE5A
#define	KEY_dead_cedilla					0xFE5B
#define	KEY_dead_ogonek					0xFE5C
#define	KEY_dead_iota					0xFE5D
#define	KEY_dead_voiced_sound				0xFE5E
#define	KEY_dead_semivoiced_sound			0xFE5F
#define	KEY_dead_belowdot				0xFE60

#define	KEY_First_Virtual_Screen				0xFED0
#define	KEY_Prev_Virtual_Screen				0xFED1
#define	KEY_Next_Virtual_Screen				0xFED2
#define	KEY_Last_Virtual_Screen				0xFED4
#define	KEY_Terminate_Server				0xFED5

#define	KEY_AccessX_Enable				0xFE70
#define	KEY_AccessX_Feedback_Enable			0xFE71
#define	KEY_RepeatKeys_Enable				0xFE72
#define	KEY_SlowKeys_Enable				0xFE73
#define	KEY_BounceKeys_Enable				0xFE74
#define	KEY_StickyKeys_Enable				0xFE75
#define	KEY_MouseKeys_Enable				0xFE76
#define	KEY_MouseKeys_Accel_Enable			0xFE77
#define	KEY_Overlay1_Enable				0xFE78
#define	KEY_Overlay2_Enable				0xFE79
#define	KEY_AudibleBell_Enable				0xFE7A

#define	KEY_Pointer_Left					0xFEE0
#define	KEY_Pointer_Right				0xFEE1
#define	KEY_Pointer_Up					0xFEE2
#define	KEY_Pointer_Down					0xFEE3
#define	KEY_Pointer_UpLeft				0xFEE4
#define	KEY_Pointer_UpRight				0xFEE5
#define	KEY_Pointer_DownLeft				0xFEE6
#define	KEY_Pointer_DownRight				0xFEE7
#define	KEY_Pointer_Button_Dflt				0xFEE8
#define	KEY_Pointer_Button1				0xFEE9
#define	KEY_Pointer_Button2				0xFEEA
#define	KEY_Pointer_Button3				0xFEEB
#define	KEY_Pointer_Button4				0xFEEC
#define	KEY_Pointer_Button5				0xFEED
#define	KEY_Pointer_DblClick_Dflt			0xFEEE
#define	KEY_Pointer_DblClick1				0xFEEF
#define	KEY_Pointer_DblClick2				0xFEF0
#define	KEY_Pointer_DblClick3				0xFEF1
#define	KEY_Pointer_DblClick4				0xFEF2
#define	KEY_Pointer_DblClick5				0xFEF3
#define	KEY_Pointer_Drag_Dflt				0xFEF4
#define	KEY_Pointer_Drag1				0xFEF5
#define	KEY_Pointer_Drag2				0xFEF6
#define	KEY_Pointer_Drag3				0xFEF7
#define	KEY_Pointer_Drag4				0xFEF8
#define	KEY_Pointer_Drag5				0xFEFD

#define	KEY_Pointer_EnableKeys				0xFEF9
#define	KEY_Pointer_Accelerate				0xFEFA
#define	KEY_Pointer_DfltBtnNext				0xFEFB
#define	KEY_Pointer_DfltBtnPrev				0xFEFC

#endif

/*
 * 3270 Terminal Keys
 * Byte 3 = 0xFD
 */

#ifdef KEY_3270
DEFKEY(3270_Duplicate,      0xFD01)
DEFKEY(3270_FieldMark,      0xFD02)
DEFKEY(3270_Right2,         0xFD03)
DEFKEY(3270_Left2,          0xFD04)
DEFKEY(3270_BackTab,        0xFD05)
DEFKEY(3270_EraseEOF,       0xFD06)
DEFKEY(3270_EraseInput,     0xFD07)
DEFKEY(3270_Reset,          0xFD08)
DEFKEY(3270_Quit,           0xFD09)
DEFKEY(3270_PA1,            0xFD0A)
DEFKEY(3270_PA2,            0xFD0B)
DEFKEY(3270_PA3,            0xFD0C)
DEFKEY(3270_Test,           0xFD0D)
DEFKEY(3270_Attn,           0xFD0E)
DEFKEY(3270_CursorBlink,    0xFD0F)
DEFKEY(3270_AltCursor,      0xFD10)
DEFKEY(3270_KeyClick,       0xFD11)
DEFKEY(3270_Jump,           0xFD12)
DEFKEY(3270_Ident,          0xFD13)
DEFKEY(3270_Rule,           0xFD14)
DEFKEY(3270_Copy,           0xFD15)
DEFKEY(3270_Play,           0xFD16)
DEFKEY(3270_Setup,          0xFD17)
DEFKEY(3270_Record,         0xFD18)
DEFKEY(3270_ChangeScreen,   0xFD19)
DEFKEY(3270_DeleteWord,     0xFD1A)
DEFKEY(3270_ExSelect,       0xFD1B)
DEFKEY(3270_CursorSelect,   0xFD1C)
DEFKEY(3270_PrintScreen,    0xFD1D)
DEFKEY(3270_Enter,          0xFD1E)
#endif

/*
 *  Latin 1
 *  Byte 3 = 0
 */
#ifdef KEY_LATIN1
DEFKEY(space,               0x020)
DEFKEY(exclam,              0x021)
DEFKEY(quotedbl,            0x022)
DEFKEY(numbersign,          0x023)
DEFKEY(dollar,              0x024)
DEFKEY(percent,             0x025)
DEFKEY(ampersand,           0x026)
DEFKEY(apostrophe,          0x027)
DEFKEY(quoteright,          0x027)	/* deprecated */
DEFKEY(parenleft,           0x028)
DEFKEY(parenright,          0x029)
DEFKEY(asterisk,            0x02a)
DEFKEY(plus,                0x02b)
DEFKEY(comma,               0x02c)
DEFKEY(minus,               0x02d)
DEFKEY(period,              0x02e)
DEFKEY(slash,               0x02f)
DEFKEY(Number_0,            0x030)
DEFKEY(Number_1,            0x031)
DEFKEY(Number_2,            0x032)
DEFKEY(Number_3,            0x033)
DEFKEY(Number_4,            0x034)
DEFKEY(Number_5,            0x035)
DEFKEY(Number_6,            0x036)
DEFKEY(Number_7,            0x037)
DEFKEY(Number_8,            0x038)
DEFKEY(Number_9,            0x039)
DEFKEY(colon,               0x03a)
DEFKEY(semicolon,           0x03b)
DEFKEY(leftangle,           0x03c)
DEFKEY(equal,               0x03d)
DEFKEY(rightangle,          0x03e)
DEFKEY(question,            0x03f)
DEFKEY(at,                  0x040)
DEFKEY(A,                   0x041)
DEFKEY(B,                   0x042)
DEFKEY(C,                   0x043)
DEFKEY(D,                   0x044)
DEFKEY(E,                   0x045)
DEFKEY(F,                   0x046)
DEFKEY(G,                   0x047)
DEFKEY(H,                   0x048)
DEFKEY(I,                   0x049)
DEFKEY(J,                   0x04a)
DEFKEY(K,                   0x04b)
DEFKEY(L,                   0x04c)
DEFKEY(M,                   0x04d)
DEFKEY(N,                   0x04e)
DEFKEY(O,                   0x04f)
DEFKEY(P,                   0x050)
DEFKEY(Q,                   0x051)
DEFKEY(R,                   0x052)
DEFKEY(S,                   0x053)
DEFKEY(T,                   0x054)
DEFKEY(U,                   0x055)
DEFKEY(V,                   0x056)
DEFKEY(W,                   0x057)
DEFKEY(X,                   0x058)
DEFKEY(Y,                   0x059)
DEFKEY(Z,                   0x05a)
DEFKEY(bracketleft,         0x05b)
DEFKEY(backslash,           0x05c)
DEFKEY(bracketright,        0x05d)
DEFKEY(asciicircum,         0x05e)
DEFKEY(underscore,          0x05f)
DEFKEY(grave,               0x060)
DEFKEY(quoteleft,           0x060)	/* deprecated */
DEFKEY(a,                   0x061)
DEFKEY(b,                   0x062)
DEFKEY(c,                   0x063)
DEFKEY(d,                   0x064)
DEFKEY(e,                   0x065)
DEFKEY(f,                   0x066)
DEFKEY(g,                   0x067)
DEFKEY(h,                   0x068)
DEFKEY(i,                   0x069)
DEFKEY(j,                   0x06a)
DEFKEY(k,                   0x06b)
DEFKEY(l,                   0x06c)
DEFKEY(m,                   0x06d)
DEFKEY(n,                   0x06e)
DEFKEY(o,                   0x06f)
DEFKEY(p,                   0x070)
DEFKEY(q,                   0x071)
DEFKEY(r,                   0x072)
DEFKEY(s,                   0x073)
DEFKEY(t,                   0x074)
DEFKEY(u,                   0x075)
DEFKEY(v,                   0x076)
DEFKEY(w,                   0x077)
DEFKEY(x,                   0x078)
DEFKEY(y,                   0x079)
DEFKEY(z,                   0x07a)
DEFKEY(braceleft,           0x07b)
DEFKEY(bar,                 0x07c)
DEFKEY(braceright,          0x07d)
DEFKEY(asciitilde,          0x07e)

DEFKEY(nobreakspace,        0x0a0)
DEFKEY(exclamdown,          0x0a1)
DEFKEY(cent,        	       0x0a2)
DEFKEY(sterling,            0x0a3)
DEFKEY(currency,            0x0a4)
DEFKEY(yen,                 0x0a5)
DEFKEY(brokenbar,           0x0a6)
DEFKEY(section,             0x0a7)
DEFKEY(diaeresis,           0x0a8)
DEFKEY(copyright,           0x0a9)
DEFKEY(ordfeminine,         0x0aa)
DEFKEY(guillemotleft,       0x0ab)	/* left angle quotation mark */
DEFKEY(notsign,             0x0ac)
DEFKEY(hyphen,              0x0ad)
DEFKEY(registered,          0x0ae)
DEFKEY(macron,              0x0af)
DEFKEY(degree,              0x0b0)
DEFKEY(plusminus,           0x0b1)
DEFKEY(twosuperior,         0x0b2)
DEFKEY(threesuperior,       0x0b3)
DEFKEY(acute,               0x0b4)
DEFKEY(mu,                  0x0b5)
DEFKEY(paragraph,           0x0b6)
DEFKEY(periodcentered,      0x0b7)
DEFKEY(cedilla,             0x0b8)
DEFKEY(onesuperior,         0x0b9)
DEFKEY(masculine,           0x0ba)
DEFKEY(guillemotright,      0x0bb)	/* right angle quotation mark */
DEFKEY(onequarter,          0x0bc)
DEFKEY(onehalf,             0x0bd)
DEFKEY(threequarters,       0x0be)
DEFKEY(questiondown,        0x0bf)
DEFKEY(Agrave,              0x0c0)
DEFKEY(Aacute,              0x0c1)
DEFKEY(Acircumflex,         0x0c2)
DEFKEY(Atilde,              0x0c3)
DEFKEY(Adiaeresis,          0x0c4)
DEFKEY(Aring,               0x0c5)
DEFKEY(AE,                  0x0c6)
DEFKEY(Ccedilla,            0x0c7)
DEFKEY(Egrave,              0x0c8)
DEFKEY(Eacute,              0x0c9)
DEFKEY(Ecircumflex,         0x0ca)
DEFKEY(Ediaeresis,          0x0cb)
DEFKEY(Igrave,              0x0cc)
DEFKEY(Iacute,              0x0cd)
DEFKEY(Icircumflex,         0x0ce)
DEFKEY(Idiaeresis,          0x0cf)
DEFKEY(ETH,                 0x0d0)
DEFKEY(Eth,                 0x0d0)	/* deprecated */
DEFKEY(Ntilde,              0x0d1)
DEFKEY(Ograve,              0x0d2)
DEFKEY(Oacute,              0x0d3)
DEFKEY(Ocircumflex,         0x0d4)
DEFKEY(Otilde,              0x0d5)
DEFKEY(Odiaeresis,          0x0d6)
DEFKEY(multiply,            0x0d7)
DEFKEY(Ooblique,            0x0d8)
DEFKEY(Ugrave,              0x0d9)
DEFKEY(Uacute,              0x0da)
DEFKEY(Ucircumflex,         0x0db)
DEFKEY(Udiaeresis,          0x0dc)
DEFKEY(Yacute,              0x0dd)
DEFKEY(THORN,               0x0de)
DEFKEY(Thorn,               0x0de)	/* deprecated */
DEFKEY(ssharp,              0x0df)
DEFKEY(agrave,              0x0e0)
DEFKEY(aacute,              0x0e1)
DEFKEY(acircumflex,         0x0e2)
DEFKEY(atilde,              0x0e3)
DEFKEY(adiaeresis,          0x0e4)
DEFKEY(aring,               0x0e5)
DEFKEY(ae,                  0x0e6)
DEFKEY(ccedilla,            0x0e7)
DEFKEY(egrave,              0x0e8)
DEFKEY(eacute,              0x0e9)
DEFKEY(ecircumflex,         0x0ea)
DEFKEY(ediaeresis,          0x0eb)
DEFKEY(igrave,              0x0ec)
DEFKEY(iacute,              0x0ed)
DEFKEY(icircumflex,         0x0ee)
DEFKEY(idiaeresis,          0x0ef)
DEFKEY(eth,                 0x0f0)
DEFKEY(ntilde,              0x0f1)
DEFKEY(ograve,              0x0f2)
DEFKEY(oacute,              0x0f3)
DEFKEY(ocircumflex,         0x0f4)
DEFKEY(otilde,              0x0f5)
DEFKEY(odiaeresis,          0x0f6)
DEFKEY(division,            0x0f7)
DEFKEY(oslash,              0x0f8)
DEFKEY(ugrave,              0x0f9)
DEFKEY(uacute,              0x0fa)
DEFKEY(ucircumflex,         0x0fb)
DEFKEY(udiaeresis,          0x0fc)
DEFKEY(yacute,              0x0fd)
DEFKEY(thorn,               0x0fe)
DEFKEY(ydiaeresis,          0x0ff)
#endif /* KEY_LATIN1 */

/*
 *   Latin 2
 *   Byte 3 = 1
 */

#ifdef KEY_LATIN2
DEFKEY(Aogonek,             0x1a1)
DEFKEY(breve,               0x1a2)
DEFKEY(Lstroke,             0x1a3)
DEFKEY(Lcaron,              0x1a5)
DEFKEY(Sacute,              0x1a6)
DEFKEY(Scaron,              0x1a9)
DEFKEY(Scedilla,            0x1aa)
DEFKEY(Tcaron,              0x1ab)
DEFKEY(Zacute,              0x1ac)
DEFKEY(Zcaron,              0x1ae)
DEFKEY(Zabovedot,           0x1af)
DEFKEY(aogonek,             0x1b1)
DEFKEY(ogonek,              0x1b2)
DEFKEY(lstroke,             0x1b3)
DEFKEY(lcaron,              0x1b5)
DEFKEY(sacute,              0x1b6)
DEFKEY(caron,               0x1b7)
DEFKEY(scaron,              0x1b9)
DEFKEY(scedilla,            0x1ba)
DEFKEY(tcaron,              0x1bb)
DEFKEY(zacute,              0x1bc)
DEFKEY(doubleacute,         0x1bd)
DEFKEY(zcaron,              0x1be)
DEFKEY(zabovedot,           0x1bf)
DEFKEY(Racute,              0x1c0)
DEFKEY(Abreve,              0x1c3)
DEFKEY(Lacute,              0x1c5)
DEFKEY(Cacute,              0x1c6)
DEFKEY(Ccaron,              0x1c8)
DEFKEY(Eogonek,             0x1ca)
DEFKEY(Ecaron,              0x1cc)
DEFKEY(Dcaron,              0x1cf)
DEFKEY(Dstroke,             0x1d0)
DEFKEY(Nacute,              0x1d1)
DEFKEY(Ncaron,              0x1d2)
DEFKEY(Odoubleacute,        0x1d5)
DEFKEY(Rcaron,              0x1d8)
DEFKEY(Uring,               0x1d9)
DEFKEY(Udoubleacute,        0x1db)
DEFKEY(Tcedilla,            0x1de)
DEFKEY(racute,              0x1e0)
DEFKEY(abreve,              0x1e3)
DEFKEY(lacute,              0x1e5)
DEFKEY(cacute,              0x1e6)
DEFKEY(ccaron,              0x1e8)
DEFKEY(eogonek,             0x1ea)
DEFKEY(ecaron,              0x1ec)
DEFKEY(dcaron,              0x1ef)
DEFKEY(dstroke,             0x1f0)
DEFKEY(nacute,              0x1f1)
DEFKEY(ncaron,              0x1f2)
DEFKEY(odoubleacute,        0x1f5)
DEFKEY(udoubleacute,        0x1fb)
DEFKEY(rcaron,              0x1f8)
DEFKEY(uring,               0x1f9)
DEFKEY(tcedilla,            0x1fe)
DEFKEY(abovedot,            0x1ff)
#endif /* KEY_LATIN2 */

/*
 *   Latin 3
 *   Byte 3 = 2
 */

#ifdef KEY_LATIN3
DEFKEY(Hstroke,             0x2a1)
DEFKEY(Hcircumflex,         0x2a6)
DEFKEY(Iabovedot,           0x2a9)
DEFKEY(Gbreve,              0x2ab)
DEFKEY(Jcircumflex,         0x2ac)
DEFKEY(hstroke,             0x2b1)
DEFKEY(hcircumflex,         0x2b6)
DEFKEY(idotless,            0x2b9)
DEFKEY(gbreve,              0x2bb)
DEFKEY(jcircumflex,         0x2bc)
DEFKEY(Cabovedot,           0x2c5)
DEFKEY(Ccircumflex,         0x2c6)
DEFKEY(Gabovedot,           0x2d5)
DEFKEY(Gcircumflex,         0x2d8)
DEFKEY(Ubreve,              0x2dd)
DEFKEY(Scircumflex,         0x2de)
DEFKEY(cabovedot,           0x2e5)
DEFKEY(ccircumflex,         0x2e6)
DEFKEY(gabovedot,           0x2f5)
DEFKEY(gcircumflex,         0x2f8)
DEFKEY(ubreve,              0x2fd)
DEFKEY(scircumflex,         0x2fe)
#endif /* KEY_LATIN3 */


/*
 *   Latin 4
 *   Byte 3 = 3
 */

#ifdef KEY_LATIN4
DEFKEY(kra,                 0x3a2)
DEFKEY(kappa,               0x3a2)	/* deprecated */
DEFKEY(Rcedilla,            0x3a3)
DEFKEY(Itilde,              0x3a5)
DEFKEY(Lcedilla,            0x3a6)
DEFKEY(Emacron,             0x3aa)
DEFKEY(Gcedilla,            0x3ab)
DEFKEY(Tslash,              0x3ac)
DEFKEY(rcedilla,            0x3b3)
DEFKEY(itilde,              0x3b5)
DEFKEY(lcedilla,            0x3b6)
DEFKEY(emacron,             0x3ba)
DEFKEY(gcedilla,            0x3bb)
DEFKEY(tslash,              0x3bc)
DEFKEY(ENG,                 0x3bd)
DEFKEY(eng,                 0x3bf)
DEFKEY(Amacron,             0x3c0)
DEFKEY(Iogonek,             0x3c7)
DEFKEY(Eabovedot,           0x3cc)
DEFKEY(Imacron,             0x3cf)
DEFKEY(Ncedilla,            0x3d1)
DEFKEY(Omacron,             0x3d2)
DEFKEY(Kcedilla,            0x3d3)
DEFKEY(Uogonek,             0x3d9)
DEFKEY(Utilde,              0x3dd)
DEFKEY(Umacron,             0x3de)
DEFKEY(amacron,             0x3e0)
DEFKEY(iogonek,             0x3e7)
DEFKEY(eabovedot,           0x3ec)
DEFKEY(imacron,             0x3ef)
DEFKEY(ncedilla,            0x3f1)
DEFKEY(omacron,             0x3f2)
DEFKEY(kcedilla,            0x3f3)
DEFKEY(uogonek,             0x3f9)
DEFKEY(utilde,              0x3fd)
DEFKEY(umacron,             0x3fe)
#endif /* KEY_LATIN4 */

/*
 * Katakana
 * Byte 3 = 4
 */

#ifdef KEY_KATAKANA
DEFKEY(overline,				       0x47e)
DEFKEY(kana_fullstop,                               0x4a1)
DEFKEY(kana_openingbracket,                         0x4a2)
DEFKEY(kana_closingbracket,                         0x4a3)
DEFKEY(kana_comma,                                  0x4a4)
DEFKEY(kana_conjunctive,                            0x4a5)
DEFKEY(kana_middledot,                              0x4a5)  /* deprecated */
DEFKEY(kana_WO,                                     0x4a6)
DEFKEY(kana_a,                                      0x4a7)
DEFKEY(kana_i,                                      0x4a8)
DEFKEY(kana_u,                                      0x4a9)
DEFKEY(kana_e,                                      0x4aa)
DEFKEY(kana_o,                                      0x4ab)
DEFKEY(kana_ya,                                     0x4ac)
DEFKEY(kana_yu,                                     0x4ad)
DEFKEY(kana_yo,                                     0x4ae)
DEFKEY(kana_tsu,                                    0x4af)
DEFKEY(kana_tu,                                     0x4af)  /* deprecated */
DEFKEY(prolongedsound,                              0x4b0)
DEFKEY(kana_A,                                      0x4b1)
DEFKEY(kana_I,                                      0x4b2)
DEFKEY(kana_U,                                      0x4b3)
DEFKEY(kana_E,                                      0x4b4)
DEFKEY(kana_O,                                      0x4b5)
DEFKEY(kana_KA,                                     0x4b6)
DEFKEY(kana_KI,                                     0x4b7)
DEFKEY(kana_KU,                                     0x4b8)
DEFKEY(kana_KE,                                     0x4b9)
DEFKEY(kana_KO,                                     0x4ba)
DEFKEY(kana_SA,                                     0x4bb)
DEFKEY(kana_SHI,                                    0x4bc)
DEFKEY(kana_SU,                                     0x4bd)
DEFKEY(kana_SE,                                     0x4be)
DEFKEY(kana_SO,                                     0x4bf)
DEFKEY(kana_TA,                                     0x4c0)
DEFKEY(kana_CHI,                                    0x4c1)
DEFKEY(kana_TI,                                     0x4c1)  /* deprecated */
DEFKEY(kana_TSU,                                    0x4c2)
DEFKEY(kana_TU,                                     0x4c2)  /* deprecated */
DEFKEY(kana_TE,                                     0x4c3)
DEFKEY(kana_TO,                                     0x4c4)
DEFKEY(kana_NA,                                     0x4c5)
DEFKEY(kana_NI,                                     0x4c6)
DEFKEY(kana_NU,                                     0x4c7)
DEFKEY(kana_NE,                                     0x4c8)
DEFKEY(kana_NO,                                     0x4c9)
DEFKEY(kana_HA,                                     0x4ca)
DEFKEY(kana_HI,                                     0x4cb)
DEFKEY(kana_FU,                                     0x4cc)
DEFKEY(kana_HU,                                     0x4cc)  /* deprecated */
DEFKEY(kana_HE,                                     0x4cd)
DEFKEY(kana_HO,                                     0x4ce)
DEFKEY(kana_MA,                                     0x4cf)
DEFKEY(kana_MI,                                     0x4d0)
DEFKEY(kana_MU,                                     0x4d1)
DEFKEY(kana_ME,                                     0x4d2)
DEFKEY(kana_MO,                                     0x4d3)
DEFKEY(kana_YA,                                     0x4d4)
DEFKEY(kana_YU,                                     0x4d5)
DEFKEY(kana_YO,                                     0x4d6)
DEFKEY(kana_RA,                                     0x4d7)
DEFKEY(kana_RI,                                     0x4d8)
DEFKEY(kana_RU,                                     0x4d9)
DEFKEY(kana_RE,                                     0x4da)
DEFKEY(kana_RO,                                     0x4db)
DEFKEY(kana_WA,                                     0x4dc)
DEFKEY(kana_N,                                      0x4dd)
DEFKEY(voicedsound,                                 0x4de)
DEFKEY(semivoicedsound,                             0x4df)
DEFKEY(kana_switch,          0xFF7E)  /* Alias for mode_switch */
#endif /* KEY_KATAKANA */

/*
 *  Arabic
 *  Byte 3 = 5
 */

#ifdef KEY_ARABIC
DEFKEY(Arabic_comma,                                0x5ac)
DEFKEY(Arabic_semicolon,                            0x5bb)
DEFKEY(Arabic_question_mark,                        0x5bf)
DEFKEY(Arabic_hamza,                                0x5c1)
DEFKEY(Arabic_maddaonalef,                          0x5c2)
DEFKEY(Arabic_hamzaonalef,                          0x5c3)
DEFKEY(Arabic_hamzaonwaw,                           0x5c4)
DEFKEY(Arabic_hamzaunderalef,                       0x5c5)
DEFKEY(Arabic_hamzaonyeh,                           0x5c6)
DEFKEY(Arabic_alef,                                 0x5c7)
DEFKEY(Arabic_beh,                                  0x5c8)
DEFKEY(Arabic_tehmarbuta,                           0x5c9)
DEFKEY(Arabic_teh,                                  0x5ca)
DEFKEY(Arabic_theh,                                 0x5cb)
DEFKEY(Arabic_jeem,                                 0x5cc)
DEFKEY(Arabic_hah,                                  0x5cd)
DEFKEY(Arabic_khah,                                 0x5ce)
DEFKEY(Arabic_dal,                                  0x5cf)
DEFKEY(Arabic_thal,                                 0x5d0)
DEFKEY(Arabic_ra,                                   0x5d1)
DEFKEY(Arabic_zain,                                 0x5d2)
DEFKEY(Arabic_seen,                                 0x5d3)
DEFKEY(Arabic_sheen,                                0x5d4)
DEFKEY(Arabic_sad,                                  0x5d5)
DEFKEY(Arabic_dad,                                  0x5d6)
DEFKEY(Arabic_tah,                                  0x5d7)
DEFKEY(Arabic_zah,                                  0x5d8)
DEFKEY(Arabic_ain,                                  0x5d9)
DEFKEY(Arabic_ghain,                                0x5da)
DEFKEY(Arabic_tatweel,                              0x5e0)
DEFKEY(Arabic_feh,                                  0x5e1)
DEFKEY(Arabic_qaf,                                  0x5e2)
DEFKEY(Arabic_kaf,                                  0x5e3)
DEFKEY(Arabic_lam,                                  0x5e4)
DEFKEY(Arabic_meem,                                 0x5e5)
DEFKEY(Arabic_noon,                                 0x5e6)
DEFKEY(Arabic_ha,                                   0x5e7)
DEFKEY(Arabic_heh,                                  0x5e7)  /* deprecated */
DEFKEY(Arabic_waw,                                  0x5e8)
DEFKEY(Arabic_alefmaksura,                          0x5e9)
DEFKEY(Arabic_yeh,                                  0x5ea)
DEFKEY(Arabic_fathatan,                             0x5eb)
DEFKEY(Arabic_dammatan,                             0x5ec)
DEFKEY(Arabic_kasratan,                             0x5ed)
DEFKEY(Arabic_fatha,                                0x5ee)
DEFKEY(Arabic_damma,                                0x5ef)
DEFKEY(Arabic_kasra,                                0x5f0)
DEFKEY(Arabic_shadda,                               0x5f1)
DEFKEY(Arabic_sukun,                                0x5f2)
DEFKEY(Arabic_switch,        0xFF7E)  /* Alias for mode_switch */
#endif /* KEY_ARABIC */

/*
 * Cyrillic
 * Byte 3 = 6
 */
#ifdef KEY_CYRILLIC
DEFKEY(Serbian_dje,                                 0x6a1)
DEFKEY(Macedonia_gje,                               0x6a2)
DEFKEY(Cyrillic_io,                                 0x6a3)
DEFKEY(Ukrainian_ie,                                0x6a4)
DEFKEY(Ukranian_je,                                 0x6a4)  /* deprecated */
DEFKEY(Macedonia_dse,                               0x6a5)
DEFKEY(Ukrainian_i,                                 0x6a6)
DEFKEY(Ukranian_i,                                  0x6a6)  /* deprecated */
DEFKEY(Ukrainian_yi,                                0x6a7)
DEFKEY(Ukranian_yi,                                 0x6a7)  /* deprecated */
DEFKEY(Cyrillic_je,                                 0x6a8)
DEFKEY(Serbian_je,                                  0x6a8)  /* deprecated */
DEFKEY(Cyrillic_lje,                                0x6a9)
DEFKEY(Serbian_lje,                                 0x6a9)  /* deprecated */
DEFKEY(Cyrillic_nje,                                0x6aa)
DEFKEY(Serbian_nje,                                 0x6aa)  /* deprecated */
DEFKEY(Serbian_tshe,                                0x6ab)
DEFKEY(Macedonia_kje,                               0x6ac)
DEFKEY(Byelorussian_shortu,                         0x6ae)
DEFKEY(Cyrillic_dzhe,                               0x6af)
DEFKEY(Serbian_dze,                                 0x6af)  /* deprecated */
DEFKEY(numerosign,                                  0x6b0)
DEFKEY(Serbian_DJE,                                 0x6b1)
DEFKEY(Macedonia_GJE,                               0x6b2)
DEFKEY(Cyrillic_IO,                                 0x6b3)
DEFKEY(Ukrainian_IE,                                0x6b4)
DEFKEY(Ukranian_JE,                                 0x6b4)  /* deprecated */
DEFKEY(Macedonia_DSE,                               0x6b5)
DEFKEY(Ukrainian_I,                                 0x6b6)
DEFKEY(Ukranian_I,                                  0x6b6)  /* deprecated */
DEFKEY(Ukrainian_YI,                                0x6b7)
DEFKEY(Ukranian_YI,                                 0x6b7)  /* deprecated */
DEFKEY(Cyrillic_JE,                                 0x6b8)
DEFKEY(Serbian_JE,                                  0x6b8)  /* deprecated */
DEFKEY(Cyrillic_LJE,                                0x6b9)
DEFKEY(Serbian_LJE,                                 0x6b9)  /* deprecated */
DEFKEY(Cyrillic_NJE,                                0x6ba)
DEFKEY(Serbian_NJE,                                 0x6ba)  /* deprecated */
DEFKEY(Serbian_TSHE,                                0x6bb)
DEFKEY(Macedonia_KJE,                               0x6bc)
DEFKEY(Byelorussian_SHORTU,                         0x6be)
DEFKEY(Cyrillic_DZHE,                               0x6bf)
DEFKEY(Serbian_DZE,                                 0x6bf)  /* deprecated */
DEFKEY(Cyrillic_yu,                                 0x6c0)
DEFKEY(Cyrillic_a,                                  0x6c1)
DEFKEY(Cyrillic_be,                                 0x6c2)
DEFKEY(Cyrillic_tse,                                0x6c3)
DEFKEY(Cyrillic_de,                                 0x6c4)
DEFKEY(Cyrillic_ie,                                 0x6c5)
DEFKEY(Cyrillic_ef,                                 0x6c6)
DEFKEY(Cyrillic_ghe,                                0x6c7)
DEFKEY(Cyrillic_ha,                                 0x6c8)
DEFKEY(Cyrillic_i,                                  0x6c9)
DEFKEY(Cyrillic_shorti,                             0x6ca)
DEFKEY(Cyrillic_ka,                                 0x6cb)
DEFKEY(Cyrillic_el,                                 0x6cc)
DEFKEY(Cyrillic_em,                                 0x6cd)
DEFKEY(Cyrillic_en,                                 0x6ce)
DEFKEY(Cyrillic_o,                                  0x6cf)
DEFKEY(Cyrillic_pe,                                 0x6d0)
DEFKEY(Cyrillic_ya,                                 0x6d1)
DEFKEY(Cyrillic_er,                                 0x6d2)
DEFKEY(Cyrillic_es,                                 0x6d3)
DEFKEY(Cyrillic_te,                                 0x6d4)
DEFKEY(Cyrillic_u,                                  0x6d5)
DEFKEY(Cyrillic_zhe,                                0x6d6)
DEFKEY(Cyrillic_ve,                                 0x6d7)
DEFKEY(Cyrillic_softsign,                           0x6d8)
DEFKEY(Cyrillic_yeru,                               0x6d9)
DEFKEY(Cyrillic_ze,                                 0x6da)
DEFKEY(Cyrillic_sha,                                0x6db)
DEFKEY(Cyrillic_e,                                  0x6dc)
DEFKEY(Cyrillic_shcha,                              0x6dd)
DEFKEY(Cyrillic_che,                                0x6de)
DEFKEY(Cyrillic_hardsign,                           0x6df)
DEFKEY(Cyrillic_YU,                                 0x6e0)
DEFKEY(Cyrillic_A,                                  0x6e1)
DEFKEY(Cyrillic_BE,                                 0x6e2)
DEFKEY(Cyrillic_TSE,                                0x6e3)
DEFKEY(Cyrillic_DE,                                 0x6e4)
DEFKEY(Cyrillic_IE,                                 0x6e5)
DEFKEY(Cyrillic_EF,                                 0x6e6)
DEFKEY(Cyrillic_GHE,                                0x6e7)
DEFKEY(Cyrillic_HA,                                 0x6e8)
DEFKEY(Cyrillic_I,                                  0x6e9)
DEFKEY(Cyrillic_SHORTI,                             0x6ea)
DEFKEY(Cyrillic_KA,                                 0x6eb)
DEFKEY(Cyrillic_EL,                                 0x6ec)
DEFKEY(Cyrillic_EM,                                 0x6ed)
DEFKEY(Cyrillic_EN,                                 0x6ee)
DEFKEY(Cyrillic_O,                                  0x6ef)
DEFKEY(Cyrillic_PE,                                 0x6f0)
DEFKEY(Cyrillic_YA,                                 0x6f1)
DEFKEY(Cyrillic_ER,                                 0x6f2)
DEFKEY(Cyrillic_ES,                                 0x6f3)
DEFKEY(Cyrillic_TE,                                 0x6f4)
DEFKEY(Cyrillic_U,                                  0x6f5)
DEFKEY(Cyrillic_ZHE,                                0x6f6)
DEFKEY(Cyrillic_VE,                                 0x6f7)
DEFKEY(Cyrillic_SOFTSIGN,                           0x6f8)
DEFKEY(Cyrillic_YERU,                               0x6f9)
DEFKEY(Cyrillic_ZE,                                 0x6fa)
DEFKEY(Cyrillic_SHA,                                0x6fb)
DEFKEY(Cyrillic_E,                                  0x6fc)
DEFKEY(Cyrillic_SHCHA,                              0x6fd)
DEFKEY(Cyrillic_CHE,                                0x6fe)
DEFKEY(Cyrillic_HARDSIGN,                           0x6ff)
#endif /* KEY_CYRILLIC */

/*
 * Greek
 * Byte 3 = 7
 */

#ifdef KEY_GREEK
DEFKEY(Greek_ALPHAaccent,                           0x7a1)
DEFKEY(Greek_EPSILONaccent,                         0x7a2)
DEFKEY(Greek_ETAaccent,                             0x7a3)
DEFKEY(Greek_IOTAaccent,                            0x7a4)
DEFKEY(Greek_IOTAdiaeresis,                         0x7a5)
DEFKEY(Greek_OMICRONaccent,                         0x7a7)
DEFKEY(Greek_UPSILONaccent,                         0x7a8)
DEFKEY(Greek_UPSILONdieresis,                       0x7a9)
DEFKEY(Greek_OMEGAaccent,                           0x7ab)
DEFKEY(Greek_accentdieresis,                        0x7ae)
DEFKEY(Greek_horizbar,                              0x7af)
DEFKEY(Greek_alphaaccent,                           0x7b1)
DEFKEY(Greek_epsilonaccent,                         0x7b2)
DEFKEY(Greek_etaaccent,                             0x7b3)
DEFKEY(Greek_iotaaccent,                            0x7b4)
DEFKEY(Greek_iotadieresis,                          0x7b5)
DEFKEY(Greek_iotaaccentdieresis,                    0x7b6)
DEFKEY(Greek_omicronaccent,                         0x7b7)
DEFKEY(Greek_upsilonaccent,                         0x7b8)
DEFKEY(Greek_upsilondieresis,                       0x7b9)
DEFKEY(Greek_upsilonaccentdieresis,                 0x7ba)
DEFKEY(Greek_omegaaccent,                           0x7bb)
DEFKEY(Greek_ALPHA,                                 0x7c1)
DEFKEY(Greek_BETA,                                  0x7c2)
DEFKEY(Greek_GAMMA,                                 0x7c3)
DEFKEY(Greek_DELTA,                                 0x7c4)
DEFKEY(Greek_EPSILON,                               0x7c5)
DEFKEY(Greek_ZETA,                                  0x7c6)
DEFKEY(Greek_ETA,                                   0x7c7)
DEFKEY(Greek_THETA,                                 0x7c8)
DEFKEY(Greek_IOTA,                                  0x7c9)
DEFKEY(Greek_KAPPA,                                 0x7ca)
DEFKEY(Greek_LAMDA,                                 0x7cb)
DEFKEY(Greek_LAMBDA,                                0x7cb)
DEFKEY(Greek_MU,                                    0x7cc)
DEFKEY(Greek_NU,                                    0x7cd)
DEFKEY(Greek_XI,                                    0x7ce)
DEFKEY(Greek_OMICRON,                               0x7cf)
DEFKEY(Greek_PI,                                    0x7d0)
DEFKEY(Greek_RHO,                                   0x7d1)
DEFKEY(Greek_SIGMA,                                 0x7d2)
DEFKEY(Greek_TAU,                                   0x7d4)
DEFKEY(Greek_UPSILON,                               0x7d5)
DEFKEY(Greek_PHI,                                   0x7d6)
DEFKEY(Greek_CHI,                                   0x7d7)
DEFKEY(Greek_PSI,                                   0x7d8)
DEFKEY(Greek_OMEGA,                                 0x7d9)
DEFKEY(Greek_alpha,                                 0x7e1)
DEFKEY(Greek_beta,                                  0x7e2)
DEFKEY(Greek_gamma,                                 0x7e3)
DEFKEY(Greek_delta,                                 0x7e4)
DEFKEY(Greek_epsilon,                               0x7e5)
DEFKEY(Greek_zeta,                                  0x7e6)
DEFKEY(Greek_eta,                                   0x7e7)
DEFKEY(Greek_theta,                                 0x7e8)
DEFKEY(Greek_iota,                                  0x7e9)
DEFKEY(Greek_kappa,                                 0x7ea)
DEFKEY(Greek_lamda,                                 0x7eb)
DEFKEY(Greek_lambda,                                0x7eb)
DEFKEY(Greek_mu,                                    0x7ec)
DEFKEY(Greek_nu,                                    0x7ed)
DEFKEY(Greek_xi,                                    0x7ee)
DEFKEY(Greek_omicron,                               0x7ef)
DEFKEY(Greek_pi,                                    0x7f0)
DEFKEY(Greek_rho,                                   0x7f1)
DEFKEY(Greek_sigma,                                 0x7f2)
DEFKEY(Greek_finalsmallsigma,                       0x7f3)
DEFKEY(Greek_tau,                                   0x7f4)
DEFKEY(Greek_upsilon,                               0x7f5)
DEFKEY(Greek_phi,                                   0x7f6)
DEFKEY(Greek_chi,                                   0x7f7)
DEFKEY(Greek_psi,                                   0x7f8)
DEFKEY(Greek_omega,                                 0x7f9)
DEFKEY(Greek_switch,         0xFF7E)  /* Alias for mode_switch */
#endif /* KEY_GREEK */

/*
 * Technical
 * Byte 3 = 8
 */

#ifdef KEY_TECHNICAL
DEFKEY(leftradical,                                 0x8a1)
DEFKEY(topleftradical,                              0x8a2)
DEFKEY(horizconnector,                              0x8a3)
DEFKEY(topintegral,                                 0x8a4)
DEFKEY(botintegral,                                 0x8a5)
DEFKEY(vertconnector,                               0x8a6)
DEFKEY(topleftsqbracket,                            0x8a7)
DEFKEY(botleftsqbracket,                            0x8a8)
DEFKEY(toprightsqbracket,                           0x8a9)
DEFKEY(botrightsqbracket,                           0x8aa)
DEFKEY(topleftparens,                               0x8ab)
DEFKEY(botleftparens,                               0x8ac)
DEFKEY(toprightparens,                              0x8ad)
DEFKEY(botrightparens,                              0x8ae)
DEFKEY(leftmiddlecurlybrace,                        0x8af)
DEFKEY(rightmiddlecurlybrace,                       0x8b0)
DEFKEY(topleftsummation,                            0x8b1)
DEFKEY(botleftsummation,                            0x8b2)
DEFKEY(topvertsummationconnector,                   0x8b3)
DEFKEY(botvertsummationconnector,                   0x8b4)
DEFKEY(toprightsummation,                           0x8b5)
DEFKEY(botrightsummation,                           0x8b6)
DEFKEY(rightmiddlesummation,                        0x8b7)
DEFKEY(lessthanequal,                               0x8bc)
DEFKEY(notequal,                                    0x8bd)
DEFKEY(greaterthanequal,                            0x8be)
DEFKEY(integral,                                    0x8bf)
DEFKEY(therefore,                                   0x8c0)
DEFKEY(variation,                                   0x8c1)
DEFKEY(infinity,                                    0x8c2)
DEFKEY(nabla,                                       0x8c5)
DEFKEY(approximate,                                 0x8c8)
DEFKEY(similarequal,                                0x8c9)
DEFKEY(ifonlyif,                                    0x8cd)
DEFKEY(implies,                                     0x8ce)
DEFKEY(identical,                                   0x8cf)
DEFKEY(radical,                                     0x8d6)
DEFKEY(includedin,                                  0x8da)
DEFKEY(includes,                                    0x8db)
DEFKEY(intersection,                                0x8dc)
DEFKEY(union,                                       0x8dd)
DEFKEY(logicaland,                                  0x8de)
DEFKEY(logicalor,                                   0x8df)
DEFKEY(partialderivative,                           0x8ef)
DEFKEY(function,                                    0x8f6)
DEFKEY(leftarrow,                                   0x8fb)
DEFKEY(uparrow,                                     0x8fc)
DEFKEY(rightarrow,                                  0x8fd)
DEFKEY(downarrow,                                   0x8fe)
#endif /* KEY_TECHNICAL */

/*
 *  Special
 *  Byte 3 = 9
 */

#ifdef KEY_SPECIAL
DEFKEY(blank,                                       0x9df)
DEFKEY(soliddiamond,                                0x9e0)
DEFKEY(checkerboard,                                0x9e1)
DEFKEY(ht,                                          0x9e2)
DEFKEY(ff,                                          0x9e3)
DEFKEY(cr,                                          0x9e4)
DEFKEY(lf,                                          0x9e5)
DEFKEY(nl,                                          0x9e8)
DEFKEY(vt,                                          0x9e9)
DEFKEY(lowrightcorner,                              0x9ea)
DEFKEY(uprightcorner,                               0x9eb)
DEFKEY(upleftcorner,                                0x9ec)
DEFKEY(lowleftcorner,                               0x9ed)
DEFKEY(crossinglines,                               0x9ee)
DEFKEY(horizlinescan1,                              0x9ef)
DEFKEY(horizlinescan3,                              0x9f0)
DEFKEY(horizlinescan5,                              0x9f1)
DEFKEY(horizlinescan7,                              0x9f2)
DEFKEY(horizlinescan9,                              0x9f3)
DEFKEY(leftt,                                       0x9f4)
DEFKEY(rightt,                                      0x9f5)
DEFKEY(bott,                                        0x9f6)
DEFKEY(topt,                                        0x9f7)
DEFKEY(vertbar,                                     0x9f8)
#endif /* KEY_SPECIAL */

/*
 *  Publishing
 *  Byte 3 = a
 */

#ifdef KEY_PUBLISHING
DEFKEY(emspace,                                     0xaa1)
DEFKEY(enspace,                                     0xaa2)
DEFKEY(em3space,                                    0xaa3)
DEFKEY(em4space,                                    0xaa4)
DEFKEY(digitspace,                                  0xaa5)
DEFKEY(punctspace,                                  0xaa6)
DEFKEY(thinspace,                                   0xaa7)
DEFKEY(hairspace,                                   0xaa8)
DEFKEY(emdash,                                      0xaa9)
DEFKEY(endash,                                      0xaaa)
DEFKEY(signifblank,                                 0xaac)
DEFKEY(ellipsis,                                    0xaae)
DEFKEY(doubbaselinedot,                             0xaaf)
DEFKEY(onethird,                                    0xab0)
DEFKEY(twothirds,                                   0xab1)
DEFKEY(onefifth,                                    0xab2)
DEFKEY(twofifths,                                   0xab3)
DEFKEY(threefifths,                                 0xab4)
DEFKEY(fourfifths,                                  0xab5)
DEFKEY(onesixth,                                    0xab6)
DEFKEY(fivesixths,                                  0xab7)
DEFKEY(careof,                                      0xab8)
DEFKEY(figdash,                                     0xabb)
DEFKEY(leftanglebracket,                            0xabc)
DEFKEY(decimalpoint,                                0xabd)
DEFKEY(rightanglebracket,                           0xabe)
DEFKEY(marker,                                      0xabf)
DEFKEY(oneeighth,                                   0xac3)
DEFKEY(threeeighths,                                0xac4)
DEFKEY(fiveeighths,                                 0xac5)
DEFKEY(seveneighths,                                0xac6)
DEFKEY(trademark,                                   0xac9)
DEFKEY(signaturemark,                               0xaca)
DEFKEY(trademarkincircle,                           0xacb)
DEFKEY(leftopentriangle,                            0xacc)
DEFKEY(rightopentriangle,                           0xacd)
DEFKEY(emopencircle,                                0xace)
DEFKEY(emopenrectangle,                             0xacf)
DEFKEY(leftsinglequotemark,                         0xad0)
DEFKEY(rightsinglequotemark,                        0xad1)
DEFKEY(leftdoublequotemark,                         0xad2)
DEFKEY(rightdoublequotemark,                        0xad3)
DEFKEY(prescription,                                0xad4)
DEFKEY(minutes,                                     0xad6)
DEFKEY(seconds,                                     0xad7)
DEFKEY(latincross,                                  0xad9)
DEFKEY(hexagram,                                    0xada)
DEFKEY(filledrectbullet,                            0xadb)
DEFKEY(filledlefttribullet,                         0xadc)
DEFKEY(filledrighttribullet,                        0xadd)
DEFKEY(emfilledcircle,                              0xade)
DEFKEY(emfilledrect,                                0xadf)
DEFKEY(enopencircbullet,                            0xae0)
DEFKEY(enopensquarebullet,                          0xae1)
DEFKEY(openrectbullet,                              0xae2)
DEFKEY(opentribulletup,                             0xae3)
DEFKEY(opentribulletdown,                           0xae4)
DEFKEY(openstar,                                    0xae5)
DEFKEY(enfilledcircbullet,                          0xae6)
DEFKEY(enfilledsqbullet,                            0xae7)
DEFKEY(filledtribulletup,                           0xae8)
DEFKEY(filledtribulletdown,                         0xae9)
DEFKEY(leftpointer,                                 0xaea)
DEFKEY(rightpointer,                                0xaeb)
DEFKEY(club,                                        0xaec)
DEFKEY(diamond,                                     0xaed)
DEFKEY(heart,                                       0xaee)
DEFKEY(maltesecross,                                0xaf0)
DEFKEY(dagger,                                      0xaf1)
DEFKEY(doubledagger,                                0xaf2)
DEFKEY(checkmark,                                   0xaf3)
DEFKEY(ballotcross,                                 0xaf4)
DEFKEY(musicalsharp,                                0xaf5)
DEFKEY(musicalflat,                                 0xaf6)
DEFKEY(malesymbol,                                  0xaf7)
DEFKEY(femalesymbol,                                0xaf8)
DEFKEY(telephone,                                   0xaf9)
DEFKEY(telephonerecorder,                           0xafa)
DEFKEY(phonographcopyright,                         0xafb)
DEFKEY(caret,                                       0xafc)
DEFKEY(singlelowquotemark,                          0xafd)
DEFKEY(doublelowquotemark,                          0xafe)
DEFKEY(cursor,                                      0xaff)
#endif /* KEY_PUBLISHING */

/*
 *  APL
 *  Byte 3 = b
 */

#ifdef KEY_APL
DEFKEY(leftcaret,                                   0xba3)
DEFKEY(rightcaret,                                  0xba6)
DEFKEY(downcaret,                                   0xba8)
DEFKEY(upcaret,                                     0xba9)
DEFKEY(overbar,                                     0xbc0)
DEFKEY(downtack,                                    0xbc2)
DEFKEY(upshoe,                                      0xbc3)
DEFKEY(downstile,                                   0xbc4)
DEFKEY(underbar,                                    0xbc6)
DEFKEY(jot,                                         0xbca)
DEFKEY(quad,                                        0xbcc)
DEFKEY(uptack,                                      0xbce)
DEFKEY(circle,                                      0xbcf)
DEFKEY(upstile,                                     0xbd3)
DEFKEY(downshoe,                                    0xbd6)
DEFKEY(rightshoe,                                   0xbd8)
DEFKEY(leftshoe,                                    0xbda)
DEFKEY(lefttack,                                    0xbdc)
DEFKEY(righttack,                                   0xbfc)
#endif /* KEY_APL */

/*
 * Hebrew
 * Byte 3 = c
 */

#ifdef KEY_HEBREW
DEFKEY(hebrew_doublelowline,                        0xcdf)
DEFKEY(hebrew_aleph,                                0xce0)
DEFKEY(hebrew_bet,                                  0xce1)
DEFKEY(hebrew_beth,                                 0xce1)  /* deprecated */
DEFKEY(hebrew_gimel,                                0xce2)
DEFKEY(hebrew_gimmel,                               0xce2)  /* deprecated */
DEFKEY(hebrew_dalet,                                0xce3)
DEFKEY(hebrew_daleth,                               0xce3)  /* deprecated */
DEFKEY(hebrew_he,                                   0xce4)
DEFKEY(hebrew_waw,                                  0xce5)
DEFKEY(hebrew_zain,                                 0xce6)
DEFKEY(hebrew_zayin,                                0xce6)  /* deprecated */
DEFKEY(hebrew_chet,                                 0xce7)
DEFKEY(hebrew_het,                                  0xce7)  /* deprecated */
DEFKEY(hebrew_tet,                                  0xce8)
DEFKEY(hebrew_teth,                                 0xce8)  /* deprecated */
DEFKEY(hebrew_yod,                                  0xce9)
DEFKEY(hebrew_finalkaph,                            0xcea)
DEFKEY(hebrew_kaph,                                 0xceb)
DEFKEY(hebrew_lamed,                                0xcec)
DEFKEY(hebrew_finalmem,                             0xced)
DEFKEY(hebrew_mem,                                  0xcee)
DEFKEY(hebrew_finalnun,                             0xcef)
DEFKEY(hebrew_nun,                                  0xcf0)
DEFKEY(hebrew_samech,                               0xcf1)
DEFKEY(hebrew_samekh,                               0xcf1)  /* deprecated */
DEFKEY(hebrew_ayin,                                 0xcf2)
DEFKEY(hebrew_finalpe,                              0xcf3)
DEFKEY(hebrew_pe,                                   0xcf4)
DEFKEY(hebrew_finalzade,                            0xcf5)
DEFKEY(hebrew_finalzadi,                            0xcf5)  /* deprecated */
DEFKEY(hebrew_zade,                                 0xcf6)
DEFKEY(hebrew_zadi,                                 0xcf6)  /* deprecated */
DEFKEY(hebrew_qoph,                                 0xcf7)
DEFKEY(hebrew_kuf,                                  0xcf7)  /* deprecated */
DEFKEY(hebrew_resh,                                 0xcf8)
DEFKEY(hebrew_shin,                                 0xcf9)
DEFKEY(hebrew_taw,                                  0xcfa)
DEFKEY(hebrew_taf,                                  0xcfa)  /* deprecated */
DEFKEY(Hebrew_switch,        0xFF7E)  /* Alias for mode_switch */
#endif /* KEY_HEBREW */

/*
 * Thai
 * Byte 3 = d
 */

#ifdef KEY_THAI
DEFKEY(Thai_kokai,					0xda1)
DEFKEY(Thai_khokhai,					0xda2)
DEFKEY(Thai_khokhuat,				0xda3)
DEFKEY(Thai_khokhwai,				0xda4)
DEFKEY(Thai_khokhon,					0xda5)
DEFKEY(Thai_khorakhang,			        0xda6)  
DEFKEY(Thai_ngongu,					0xda7)  
DEFKEY(Thai_chochan,					0xda8)  
DEFKEY(Thai_choching,				0xda9)   
DEFKEY(Thai_chochang,				0xdaa)  
DEFKEY(Thai_soso,					0xdab)
DEFKEY(Thai_chochoe,					0xdac)
DEFKEY(Thai_yoying,					0xdad)
DEFKEY(Thai_dochada,					0xdae)
DEFKEY(Thai_topatak,					0xdaf)
DEFKEY(Thai_thothan,					0xdb0)
DEFKEY(Thai_thonangmontho,			        0xdb1)
DEFKEY(Thai_thophuthao,			        0xdb2)
DEFKEY(Thai_nonen,					0xdb3)
DEFKEY(Thai_dodek,					0xdb4)
DEFKEY(Thai_totao,					0xdb5)
DEFKEY(Thai_thothung,				0xdb6)
DEFKEY(Thai_thothahan,				0xdb7)
DEFKEY(Thai_thothong,	 			0xdb8)
DEFKEY(Thai_nonu,					0xdb9)
DEFKEY(Thai_bobaimai,				0xdba)
DEFKEY(Thai_popla,					0xdbb)
DEFKEY(Thai_phophung,				0xdbc)
DEFKEY(Thai_fofa,					0xdbd)
DEFKEY(Thai_phophan,					0xdbe)
DEFKEY(Thai_fofan,					0xdbf)
DEFKEY(Thai_phosamphao,			        0xdc0)
DEFKEY(Thai_moma,					0xdc1)
DEFKEY(Thai_yoyak,					0xdc2)
DEFKEY(Thai_rorua,					0xdc3)
DEFKEY(Thai_ru,					0xdc4)
DEFKEY(Thai_loling,					0xdc5)
DEFKEY(Thai_lu,					0xdc6)
DEFKEY(Thai_wowaen,					0xdc7)
DEFKEY(Thai_sosala,					0xdc8)
DEFKEY(Thai_sorusi,					0xdc9)
DEFKEY(Thai_sosua,					0xdca)
DEFKEY(Thai_hohip,					0xdcb)
DEFKEY(Thai_lochula,					0xdcc)
DEFKEY(Thai_oang,					0xdcd)
DEFKEY(Thai_honokhuk,				0xdce)
DEFKEY(Thai_paiyannoi,				0xdcf)
DEFKEY(Thai_saraa,					0xdd0)
DEFKEY(Thai_maihanakat,				0xdd1)
DEFKEY(Thai_saraaa,					0xdd2)
DEFKEY(Thai_saraam,					0xdd3)
DEFKEY(Thai_sarai,					0xdd4)   
DEFKEY(Thai_saraii,					0xdd5)   
DEFKEY(Thai_saraue,					0xdd6)    
DEFKEY(Thai_sarauee,					0xdd7)    
DEFKEY(Thai_sarau,					0xdd8)    
DEFKEY(Thai_sarauu,					0xdd9)   
DEFKEY(Thai_phinthu,					0xdda)
DEFKEY(Thai_maihanakat_maitho,   			0xdde)
DEFKEY(Thai_baht,					0xddf)
DEFKEY(Thai_sarae,					0xde0)    
DEFKEY(Thai_saraae,					0xde1)
DEFKEY(Thai_sarao,					0xde2)
DEFKEY(Thai_saraaimaimuan,				0xde3)   
DEFKEY(Thai_saraaimaimalai,				0xde4)  
DEFKEY(Thai_lakkhangyao,				0xde5)
DEFKEY(Thai_maiyamok,				0xde6)
DEFKEY(Thai_maitaikhu,				0xde7)
DEFKEY(Thai_maiek,					0xde8)   
DEFKEY(Thai_maitho,					0xde9)
DEFKEY(Thai_maitri,					0xdea)
DEFKEY(Thai_maichattawa,				0xdeb)
DEFKEY(Thai_thanthakhat,				0xdec)
DEFKEY(Thai_nikhahit,				0xded)
DEFKEY(Thai_leksun,					0xdf0) 
DEFKEY(Thai_leknung,					0xdf1)  
DEFKEY(Thai_leksong,					0xdf2) 
DEFKEY(Thai_leksam,					0xdf3)
DEFKEY(Thai_leksi,					0xdf4)  
DEFKEY(Thai_lekha,					0xdf5)  
DEFKEY(Thai_lekhok,					0xdf6)  
DEFKEY(Thai_lekchet,					0xdf7)  
DEFKEY(Thai_lekpaet,					0xdf8)  
DEFKEY(Thai_lekkao,					0xdf9) 
#endif /* KEY_THAI */

/*
 *   Korean
 *   Byte 3 = e
 */

#ifdef KEY_KOREAN

DEFKEY(Hangul,		0xff31)    /* Hangul start/stop(toggle) */
DEFKEY(Hangul_Start,		0xff32)    /* Hangul start */
DEFKEY(Hangul_End,		0xff33)    /* Hangul end, English start */
DEFKEY(Hangul_Hanja,		0xff34)    /* Start Hangul->Hanja Conversion */
DEFKEY(Hangul_Jamo,		0xff35)    /* Hangul Jamo mode */
DEFKEY(Hangul_Romaja,	0xff36)    /* Hangul Romaja mode */
DEFKEY(Hangul_Codeinput,	0xff37)    /* Hangul code input mode */
DEFKEY(Hangul_Jeonja,	0xff38)    /* Jeonja mode */
DEFKEY(Hangul_Banja,		0xff39)    /* Banja mode */
DEFKEY(Hangul_PreHanja,	0xff3a)    /* Pre Hanja conversion */
DEFKEY(Hangul_PostHanja,	0xff3b)    /* Post Hanja conversion */
DEFKEY(Hangul_SingleCandidate,	0xff3c)    /* Single candidate */
DEFKEY(Hangul_MultipleCandidate,	0xff3d)    /* Multiple candidate */
DEFKEY(Hangul_PreviousCandidate,	0xff3e)    /* Previous candidate */
DEFKEY(Hangul_Special,	0xff3f)    /* Special symbols */
DEFKEY(Hangul_switch,	0xFF7E)    /* Alias for mode_switch */

/* Hangul Consonant Characters */
DEFKEY(Hangul_Kiyeog,				0xea1)
DEFKEY(Hangul_SsangKiyeog,				0xea2)
DEFKEY(Hangul_KiyeogSios,				0xea3)
DEFKEY(Hangul_Nieun,					0xea4)
DEFKEY(Hangul_NieunJieuj,				0xea5)
DEFKEY(Hangul_NieunHieuh,				0xea6)
DEFKEY(Hangul_Dikeud,				0xea7)
DEFKEY(Hangul_SsangDikeud,				0xea8)
DEFKEY(Hangul_Rieul,					0xea9)
DEFKEY(Hangul_RieulKiyeog,				0xeaa)
DEFKEY(Hangul_RieulMieum,				0xeab)
DEFKEY(Hangul_RieulPieub,				0xeac)
DEFKEY(Hangul_RieulSios,				0xead)
DEFKEY(Hangul_RieulTieut,				0xeae)
DEFKEY(Hangul_RieulPhieuf,				0xeaf)
DEFKEY(Hangul_RieulHieuh,				0xeb0)
DEFKEY(Hangul_Mieum,					0xeb1)
DEFKEY(Hangul_Pieub,					0xeb2)
DEFKEY(Hangul_SsangPieub,				0xeb3)
DEFKEY(Hangul_PieubSios,				0xeb4)
DEFKEY(Hangul_Sios,					0xeb5)
DEFKEY(Hangul_SsangSios,				0xeb6)
DEFKEY(Hangul_Ieung,					0xeb7)
DEFKEY(Hangul_Jieuj,					0xeb8)
DEFKEY(Hangul_SsangJieuj,				0xeb9)
DEFKEY(Hangul_Cieuc,					0xeba)
DEFKEY(Hangul_Khieuq,				0xebb)
DEFKEY(Hangul_Tieut,					0xebc)
DEFKEY(Hangul_Phieuf,				0xebd)
DEFKEY(Hangul_Hieuh,					0xebe)

/* Hangul Vowel Characters */
DEFKEY(Hangul_A,					0xebf)
DEFKEY(Hangul_AE,					0xec0)
DEFKEY(Hangul_YA,					0xec1)
DEFKEY(Hangul_YAE,					0xec2)
DEFKEY(Hangul_EO,					0xec3)
DEFKEY(Hangul_E,					0xec4)
DEFKEY(Hangul_YEO,					0xec5)
DEFKEY(Hangul_YE,					0xec6)
DEFKEY(Hangul_O,					0xec7)
DEFKEY(Hangul_WA,					0xec8)
DEFKEY(Hangul_WAE,					0xec9)
DEFKEY(Hangul_OE,					0xeca)
DEFKEY(Hangul_YO,					0xecb)
DEFKEY(Hangul_U,					0xecc)
DEFKEY(Hangul_WEO,					0xecd)
DEFKEY(Hangul_WE,					0xece)
DEFKEY(Hangul_WI,					0xecf)
DEFKEY(Hangul_YU,					0xed0)
DEFKEY(Hangul_EU,					0xed1)
DEFKEY(Hangul_YI,					0xed2)
DEFKEY(Hangul_I,					0xed3)

/* Hangul syllable-final (JongSeong) Characters */
DEFKEY(Hangul_J_Kiyeog,				0xed4)
DEFKEY(Hangul_J_SsangKiyeog,				0xed5)
DEFKEY(Hangul_J_KiyeogSios,				0xed6)
DEFKEY(Hangul_J_Nieun,				0xed7)
DEFKEY(Hangul_J_NieunJieuj,				0xed8)
DEFKEY(Hangul_J_NieunHieuh,				0xed9)
DEFKEY(Hangul_J_Dikeud,				0xeda)
DEFKEY(Hangul_J_Rieul,				0xedb)
DEFKEY(Hangul_J_RieulKiyeog,				0xedc)
DEFKEY(Hangul_J_RieulMieum,				0xedd)
DEFKEY(Hangul_J_RieulPieub,				0xede)
DEFKEY(Hangul_J_RieulSios,				0xedf)
DEFKEY(Hangul_J_RieulTieut,				0xee0)
DEFKEY(Hangul_J_RieulPhieuf,				0xee1)
DEFKEY(Hangul_J_RieulHieuh,				0xee2)
DEFKEY(Hangul_J_Mieum,				0xee3)
DEFKEY(Hangul_J_Pieub,				0xee4)
DEFKEY(Hangul_J_PieubSios,				0xee5)
DEFKEY(Hangul_J_Sios,				0xee6)
DEFKEY(Hangul_J_SsangSios,				0xee7)
DEFKEY(Hangul_J_Ieung,				0xee8)
DEFKEY(Hangul_J_Jieuj,				0xee9)
DEFKEY(Hangul_J_Cieuc,				0xeea)
DEFKEY(Hangul_J_Khieuq,				0xeeb)
DEFKEY(Hangul_J_Tieut,				0xeec)
DEFKEY(Hangul_J_Phieuf,				0xeed)
DEFKEY(Hangul_J_Hieuh,				0xeee)

/* Ancient Hangul Consonant Characters */
DEFKEY(Hangul_RieulYeorinHieuh,			0xeef)
DEFKEY(Hangul_SunkyeongeumMieum,			0xef0)
DEFKEY(Hangul_SunkyeongeumPieub,			0xef1)
DEFKEY(Hangul_PanSios,				0xef2)
DEFKEY(Hangul_KkogjiDalrinIeung,			0xef3)
DEFKEY(Hangul_SunkyeongeumPhieuf,			0xef4)
DEFKEY(Hangul_YeorinHieuh,				0xef5)

/* Ancient Hangul Vowel Characters */
DEFKEY(Hangul_AraeA,					0xef6)
DEFKEY(Hangul_AraeAE,				0xef7)

/* Ancient Hangul syllable-final (JongSeong) Characters */
DEFKEY(Hangul_J_PanSios,				0xef8)
DEFKEY(Hangul_J_KkogjiDalrinIeung,			0xef9)
DEFKEY(Hangul_J_YeorinHieuh,				0xefa)

/* Korean currency symbol */
DEFKEY(Korean_Won,					0xeff)

#endif /* KEY_KOREAN */
